//Sample using LiquidCrystal library

#include <LiquidCrystal.h>
#include <util/delay.h> 

volatile unsigned int tachBuf; 
unsigned long tachValue; 

ISR(TIMER4_CAPT_vect) 
{  
    TCNT4 = 0;  
    tachBuf = ICR4+120; 
} 
 

/*******************************************************

 

This program will test the LCD panel and the buttons

Mark Bramwell, July 2010

 

********************************************************/

 

// select the pins used on the LCD panel

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

 

// define some values used by the panel and buttons

int lcd_key     = 0;

int adc_key_in  = 0;

#define btnRIGHT  0

#define btnUP     1

#define btnDOWN   2

#define btnLEFT   3

#define btnSELECT 4

#define btnNONE   5

 

// read the buttons

int read_LCD_buttons()

{

 adc_key_in = analogRead(0);      // read the value from the sensor

 // my buttons when read are centered at these valies: 0, 144, 329, 504, 741

 // we add approx 50 to those values and check to see if we are close

 if (adc_key_in > 1000) return btnNONE; // We make this the 1st option for speed reasons since it will be the most likely result

 if (adc_key_in < 50)   return btnRIGHT; 

 if (adc_key_in < 195)  return btnUP;

 if (adc_key_in < 380)  return btnDOWN;

 if (adc_key_in < 555)  return btnLEFT;

 if (adc_key_in < 790)  return btnSELECT;  

 return btnNONE;  // when all others fail, return this...

}

 

void setup()

{

 lcd.begin(16, 2);              // start the library

 lcd.setCursor(9,0);

 lcd.print("buttons"); // print a simple message
 //
pinMode(49, INPUT);  //Вход частотомера для импульсов TTL 
  // pinMode(4, OUTPUT);//выход ШИМ для тестирования частотомера 
  // TCCR0B = TCCR0B & 0b11111000 | 2;//частота ШИМ 62500Гц 
   //analogWrite(4, 128);  //Запустить ШИМ 
   digitalWrite(49,HIGH); // включить подтяжку входа 
  Serial.begin(115200); 
   TIM_Init(); 
  _delay_ms(300); 
}

  

void loop()

{
cli(); 

 lcd.setCursor(9,1);            // move cursor to second line "1" and 9 spaces over
 lcd.print(millis()/1000);      // display seconds elapsed since power-up
 lcd.setCursor(0,1);            // move to the begining of the second line
 lcd_key = read_LCD_buttons();  // read the buttons
 switch (lcd_key)               // depending on which button was pushed, we perform an action
 {
   case btnRIGHT:
     {
     lcd.print("RIGHT ");
                         //lcd.noDisplay() ;
     break;
     }
   case btnLEFT:
     {
     lcd.print("LEFT   ");
                        //lcd.display() ;
     break;
     }
   case btnUP:
     {
     lcd.print("UP    ");
     break;
     }
   case btnDOWN:
     {
     lcd.print("DOWN  ");
     break;
     }
   case btnSELECT:
     {
     lcd.print("SELECT");
     break;
     }
     case btnNONE:
     {
       lcd.print("NONE  ");
     break;
     }
 }
 //
 //
tachValue =16000000/tachBuf; 
  //tachValue =16000/tachBuf; 
  Serial.print("freq="); 
  Serial.println(tachValue,DEC); 
  lcd.setCursor(0,0);
 lcd.print(tachValue); // print 
  //Serial.println(tachBuf,DEC);
  sei(); 
  _delay_ms(300); 


}
void TIM_Init(void) 
{ 
   TIMSK4=(1<<ICIE4);  
   TCCR4A=(0<<COM4A1)|(0<<COM4A0)|(0<<WGM41)|(0<<WGM40);   
   TCCR4B=(1<<ICNC4)|(1<<ICES4)|(0<<WGM43)|(0<<WGM42)|(0<<CS42)|(0<<CS41)|(1<<CS40);  
   TCNT4 = 0; 
} 


